VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "RegSvr32 Graphic Shell"
   ClientHeight    =   4035
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5535
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4035
   ScaleWidth      =   5535
   StartUpPosition =   2  'CenterScreen
   Begin VB.CheckBox CheckSilent 
      Caption         =   "Silent - display no message boxes"
      Height          =   285
      Left            =   1500
      TabIndex        =   5
      Top             =   3705
      Width           =   2730
   End
   Begin VB.CommandButton CommandUn 
      Caption         =   "Unregister"
      Height          =   405
      Left            =   2910
      TabIndex        =   4
      Top             =   3225
      Width           =   2565
   End
   Begin VB.CommandButton CommandReg 
      Caption         =   "Register"
      Default         =   -1  'True
      Height          =   405
      Left            =   105
      TabIndex        =   3
      Top             =   3225
      Width           =   2610
   End
   Begin VB.FileListBox File1 
      Height          =   3015
      Left            =   2625
      Pattern         =   "*.dll"
      TabIndex        =   2
      ToolTipText     =   "Double-clicking filename in this list is the same as using Register button."
      Top             =   90
      Width           =   2850
   End
   Begin VB.DirListBox Dir1 
      Height          =   2565
      Left            =   105
      TabIndex        =   1
      Top             =   525
      Width           =   2445
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   105
      TabIndex        =   0
      Top             =   105
      Width           =   2445
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Constants and declarations for getting windows\system folder
Const gstrNULL$ = ""
Const gintMAX_SIZE% = 255
Const gstrSEP_DIR$ = "\"
Const gstrSEP_URLDIR$ = "/"
Private Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long

' Get windows\system directory location
Function GetWindowsSysDir() As String
    Dim strBuf As String

    strBuf = Space$(gintMAX_SIZE)

    '
    'Get the system directory and then trim the buffer to the exact length
    'returned and add a dir sep (backslash) if the API didn't return one
    '
    If GetSystemDirectory(strBuf, gintMAX_SIZE) > 0 Then
        strBuf = StripTerminator(strBuf)
        AddDirSep strBuf
        
        GetWindowsSysDir = strBuf
    Else
        GetWindowsSysDir = gstrNULL
    End If
End Function

Private Sub CommandReg_Click()
On Error Resume Next
' check if any file is selected
If File1.ListIndex = -1 Then MsgBox "No DLL selected", vbCritical: Exit Sub
' is Silent Mode checkbox checked?
If CheckSilent.Value = 0 Then
' shell to regsvr32 for registering
Shell "RegSvr32 " & File1.Path & "\" & File1.FileName, vbNormalFocus
Else
' shell to regsvr32 for registering with silent mode
Shell "RegSvr32 /s" & File1.Path & "\" & File1.FileName, vbNormalFocus
End If
End Sub

Private Sub CommandUn_Click()
On Error Resume Next
' check if any file is selected
If File1.ListIndex = -1 Then MsgBox "No DLL selected", vbCritical: Exit Sub
' is Silent Mode checkbox checked?
If CheckSilent.Value = 0 Then
' shell to regsvr32 for unregistering
Shell "RegSvr32 /u " & File1.Path & "\" & File1.FileName, vbNormalFocus
Else
' shell to regsvr32 for unregistering with silent mode
Shell "RegSvr32 /u /s " & File1.Path & "\" & File1.FileName, vbNormalFocus
End If
End Sub

Private Sub Dir1_Change()
' dir may be moved or deleted
On Error GoTo err
' set filelist to selected dir
File1.Path = Dir1.Path
Exit Sub
err:
MsgBox "Error: " & err.Description & " (" & err.Number & ")", vbCritical
End Sub

Private Sub Drive1_Change()
' drive may be unavailable (floppy or CDRom)
On Error GoTo err
' set dirlist to selected drive
Dir1.Path = Drive1.Drive
Exit Sub
err:
MsgBox "Error: " & err.Description & " (" & err.Number & ")", vbCritical
Drive1.Drive = Dir1.Path
End Sub

Private Sub File1_DblClick()
' simulate Register button click on filelist doubleclick
CommandReg_Click
End Sub

Private Sub Form_Load()
On Error Resume Next
' usually most people store their DLLs in windows/system folder, set it
Dir1.Path = GetWindowsSysDir
End Sub

' auxiliary function for GetWindowsSysDir
Function StripTerminator(ByVal strString As String) As String
    Dim intZeroPos As Integer

    intZeroPos = InStr(strString, Chr$(0))
    If intZeroPos > 0 Then
        StripTerminator = Left$(strString, intZeroPos - 1)
    Else
        StripTerminator = strString
    End If
End Function

' auxiliary function for GetWindowsSysDir
Sub AddDirSep(strPathName As String)
    If Right(Trim(strPathName), Len(gstrSEP_URLDIR)) <> gstrSEP_URLDIR And _
       Right(Trim(strPathName), Len(gstrSEP_DIR)) <> gstrSEP_DIR Then
        strPathName = RTrim$(strPathName) & gstrSEP_DIR
    End If
End Sub


